#ifndef __KAIPREQ_H__
#define __KAIPREQ_H__

/* 
 * XXX yeah, yeah, whatever.  do the usual architectural
 * smarts here 
 */
#ifndef u16
#define u16 unsigned short
#endif

#ifndef u32
#define u32 unsigned long
#endif

#ifndef u64
#define u64 unsigned long long
#endif

#define MAX_CIPHER_NAME 32

struct kaip_stats {
    u64 freedom_rx_packets;
    u64 freedom_rx_bytes;
    u64 freedom_tx_packets;
    u64 freedom_tx_bytes;
    u64 clear_rx_packets;
    u64 clear_rx_bytes;
    u64 clear_tx_packets;
    u64 clear_tx_bytes;

    struct kaip_cycle_measurement {
        u64 cycles;
        u64 num;
    }   link_dec, link_enc, 
        telescope, mac,
        out_path, in_path;
};

struct kaip_req_route {
    u16 client_aci;
    u32 client_neighbor_id;
    u16 server_aci;
    u32 server_neighbor_id;
    char telescope_cipher_name[MAX_CIPHER_NAME];
    char *telescope_in_key_data;
    int telescope_in_key_len;
    char *telescope_out_key_data;
    int telescope_out_key_len;
    char mac_digest_name[MAX_CIPHER_NAME];
    char *mac_key_data;
    int mac_key_len;
    int exit_route;
    struct sockaddr_in fake_addr;
};

struct kaip_req_neighbor {
    struct sockaddr_in addr;
    char link_cipher_name[MAX_CIPHER_NAME];
    char *link_from_key_data[2];
    int link_from_key_len[2];
    char *link_to_key_data[2];
    int link_to_key_len[2];
    int active_to_key;
    u32 id;
};

#define KAIP_UDPBIND            1
#define KAIP_SHUTDOWN           2
#define KAIP_ADDNEIGHBOR        3
#define KAIP_GETSTATS           4
#define KAIP_SETSTATS           5
#define KAIP_ADDROUTE           6
#define KAIP_REMOVENEIGHBOR     7
#define KAIP_REMOVEROUTE        8
#define KAIP_UPDATENEIBORKEYS   9
#define KAIP_SETNETLINKADDR     10
#define KAIP_SHIFTROUTE         11

struct kaip_request {
    int cmd;
    union {
        int fd;
        struct sockaddr_nl nladdr;
        struct kaip_stats tstats;
        struct kaip_req_route troute;
        struct kaip_req_neighbor tnei;
        struct kaip_route_shift {
            struct kaip_req_route old_route, new_route;
        } rs;
    }u;
};

#endif /*__KAIPREQ_H__*/
